/*!
 * @overview RSVP - a tiny implementation of Promises/A+.
 * @copyright Copyright (c) 2014 Yehuda Katz, Tom Dale, Stefan Penner and contributors
 * @license   Licensed under MIT license
 *            See https://raw.githubusercontent.com/tildeio/rsvp.js/master/LICENSE
 * @version   3.2.1
 */

(function(){"use strict";function t(t){return"function"==typeof t||"object"==typeof t&&null!==t}function n(t){return"function"==typeof t}function r(t){return"object"==typeof t&&null!==t}function e(){}function o(t,n){for(var r=0,e=t.length;e>r;r++)if(t[r]===n)return r;return-1}function i(t){var n=t._promiseCallbacks;return n||(n=t._promiseCallbacks={}),n}function u(t,n){return"onerror"===t?void Et.on("error",n):2!==arguments.length?Et[t]:void(Et[t]=n)}function s(){setTimeout(function(){for(var t,n=0;n<At.length;n++){t=At[n];var r=t.payload;r.guid=r.key+r.id,r.childGuid=r.key+r.childId,r.error&&(r.stack=r.error.stack),Et.trigger(t.name,t.payload)}At.length=0},50)}function a(t,n,r){1===At.push({name:t,payload:{key:n._guidKey,id:n._id,eventName:t,detail:n._result,childId:r&&r._id,label:n._label,timeStamp:wt(),error:Et["instrument-with-stack"]?new Error(n._label):null}})&&s()}function c(t,n,r){var e=this,o=e._state;if(o===Nt&&!t||o===Yt&&!n)return Et.instrument&&jt("chained",e,e),e;e._onError=null;var i=new e.constructor(g,r),u=e._result;if(Et.instrument&&jt("chained",e,i),o){var s=arguments[o-1];Et.async(function(){x(o,i,s,u)})}else R(e,i,t,n);return i}function f(t,n){var r=this;if(t&&"object"==typeof t&&t.constructor===r)return t;var e=new r(g,n);return S(e,t),e}function l(t,n,r){return t===Nt?{state:"fulfilled",value:r}:{state:"rejected",reason:r}}function h(t,n,r,e){this._instanceConstructor=t,this.promise=new t(g,e),this._abortOnReject=r,this._validateInput(n)?(this._input=n,this.length=n.length,this._remaining=n.length,this._init(),0===this.length?C(this.promise,this._result):(this.length=this.length||0,this._enumerate(),0===this._remaining&&C(this.promise,this._result))):O(this.promise,this._validationError())}function p(t,n){return new kt(this,t,!0,n).promise}function _(t,n){function r(t){S(i,t)}function e(t){O(i,t)}var o=this,i=new o(g,n);if(!mt(t))return O(i,new TypeError("You must pass an array to race.")),i;for(var u=t.length,s=0;i._state===xt&&u>s;s++)R(o.resolve(t[s]),void 0,r,e);return i}function v(t,n){var r=this,e=new r(g,n);return O(e,t),e}function y(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}function d(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}function m(t,n){this._id=Mt++,this._label=n,this._state=void 0,this._result=void 0,this._subscribers=[],Et.instrument&&jt("created",this),g!==t&&("function"!=typeof t&&y(),this instanceof m?N(this,t):d())}function w(){return new TypeError("A promises callback cannot return that same promise.")}function g(){}function b(t){try{return t.then}catch(n){return Dt.error=n,Dt}}function E(t,n,r,e){try{t.call(n,r,e)}catch(o){return o}}function A(t,n,r){Et.async(function(t){var e=!1,o=E(r,n,function(r){e||(e=!0,n!==r?S(t,r,void 0):C(t,r))},function(n){e||(e=!0,O(t,n))},"Settle: "+(t._label||" unknown promise"));!e&&o&&(e=!0,O(t,o))},t)}function j(t,n){n._state===Nt?C(t,n._result):n._state===Yt?(n._onError=null,O(t,n._result)):R(n,void 0,function(r){n!==r?S(t,r,void 0):C(t,r)},function(n){O(t,n)})}function T(t,r,e){r.constructor===t.constructor&&e===Tt&&constructor.resolve===St?j(t,r):e===Dt?O(t,Dt.error):void 0===e?C(t,r):n(e)?A(t,r,e):C(t,r)}function S(n,r){n===r?C(n,r):t(r)?T(n,r,b(r)):C(n,r)}function k(t){t._onError&&t._onError(t._result),I(t)}function C(t,n){t._state===xt&&(t._result=n,t._state=Nt,0===t._subscribers.length?Et.instrument&&jt("fulfilled",t):Et.async(I,t))}function O(t,n){t._state===xt&&(t._state=Yt,t._result=n,Et.async(k,t))}function R(t,n,r,e){var o=t._subscribers,i=o.length;t._onError=null,o[i]=n,o[i+Nt]=r,o[i+Yt]=e,0===i&&t._state&&Et.async(I,t)}function I(t){var n=t._subscribers,r=t._state;if(Et.instrument&&jt(r===Nt?"fulfilled":"rejected",t),0!==n.length){for(var e,o,i=t._result,u=0;u<n.length;u+=3)e=n[u],o=n[u+r],e?x(r,e,o,i):o(i);t._subscribers.length=0}}function M(){this.error=null}function P(t,n){try{return t(n)}catch(r){return Kt.error=r,Kt}}function x(t,r,e,o){var i,u,s,a,c=n(e);if(c){if(i=P(e,o),i===Kt?(a=!0,u=i.error,i=null):s=!0,r===i)return void O(r,w())}else i=o,s=!0;r._state!==xt||(c&&s?S(r,i):a?O(r,u):t===Nt?C(r,i):t===Yt&&O(r,i))}function N(t,n){var r=!1;try{n(function(n){r||(r=!0,S(t,n))},function(n){r||(r=!0,O(t,n))})}catch(e){O(t,e)}}function Y(t,n,r){this._superConstructor(t,n,!1,r)}function D(t,n){return new Y(Pt,t,n).promise}function K(t,n){return Pt.all(t,n)}function U(t,n){Jt[Lt]=t,Jt[Lt+1]=n,Lt+=2,2===Lt&&qt()}function q(){var t=process.nextTick,n=process.versions.node.match(/^(?:(\d+)\.)?(?:(\d+)\.)?(\*|\d+)$/);return Array.isArray(n)&&"0"===n[1]&&"10"===n[2]&&(t=setImmediate),function(){t(W)}}function F(){return function(){Ut(W)}}function G(){var t=0,n=new zt(W),r=document.createTextNode("");return n.observe(r,{characterData:!0}),function(){r.data=t=++t%2}}function L(){var t=new MessageChannel;return t.port1.onmessage=W,function(){t.port2.postMessage(0)}}function V(){return function(){setTimeout(W,1)}}function W(){for(var t=0;Lt>t;t+=2){var n=Jt[t],r=Jt[t+1];n(r),Jt[t]=void 0,Jt[t+1]=void 0}Lt=0}function $(){try{var t=require,n=t("vertx");return Ut=n.runOnLoop||n.runOnContext,F()}catch(r){return V()}}function z(t){var n={};return n.promise=new Pt(function(t,r){n.resolve=t,n.reject=r},t),n}function B(t,r,e){return Pt.all(t,e).then(function(t){if(!n(r))throw new TypeError("You must pass a function as filter's second argument.");for(var o=t.length,i=new Array(o),u=0;o>u;u++)i[u]=r(t[u]);return Pt.all(i,e).then(function(n){for(var r=new Array(o),e=0,i=0;o>i;i++)n[i]&&(r[e]=t[i],e++);return r.length=e,r})})}function H(t,n,r){this._superConstructor(t,n,!0,r)}function J(t,n,r){this._superConstructor(t,n,!1,r)}function Q(t,n){return new J(Pt,t,n).promise}function X(t,n){return new Zt(Pt,t,n).promise}function Z(t,r,e){return Pt.all(t,e).then(function(t){if(!n(r))throw new TypeError("You must pass a function as map's second argument.");for(var o=t.length,i=new Array(o),u=0;o>u;u++)i[u]=r(t[u]);return Pt.all(i,e)})}function tt(){this.value=void 0}function nt(t){try{return t.then}catch(n){return on.value=n,on}}function rt(t,n,r){try{t.apply(n,r)}catch(e){return on.value=e,on}}function et(t,n){for(var r,e,o={},i=t.length,u=new Array(i),s=0;i>s;s++)u[s]=t[s];for(e=0;e<n.length;e++)r=n[e],o[r]=u[e+1];return o}function ot(t){for(var n=t.length,r=new Array(n-1),e=1;n>e;e++)r[e-1]=t[e];return r}function it(t,n){return{then:function(r,e){return t.call(n,r,e)}}}function ut(t,n){var r=function(){for(var r,e=this,o=arguments.length,i=new Array(o+1),u=!1,s=0;o>s;++s){if(r=arguments[s],!u){if(u=ct(r),u===un){var a=new Pt(g);return O(a,un.value),a}u&&u!==!0&&(r=it(u,r))}i[s]=r}var c=new Pt(g);return i[o]=function(t,r){t?O(c,t):void 0===n?S(c,r):n===!0?S(c,ot(arguments)):mt(n)?S(c,et(arguments,n)):S(c,r)},u?at(c,i,t,e):st(c,i,t,e)};return r.__proto__=t,r}function st(t,n,r,e){var o=rt(r,e,n);return o===on&&O(t,o.value),t}function at(t,n,r,e){return Pt.all(n).then(function(n){var o=rt(r,e,n);return o===on&&O(t,o.value),t})}function ct(t){return t&&"object"==typeof t?t.constructor===Pt?!0:nt(t):!1}function ft(t,n){return Pt.race(t,n)}function lt(t,n){return Pt.reject(t,n)}function ht(t,n){return Pt.resolve(t,n)}function pt(t){throw setTimeout(function(){throw t}),t}function _t(t,n){Et.async(t,n)}function vt(){Et.on.apply(Et,arguments)}function yt(){Et.off.apply(Et,arguments)}var dt;dt=Array.isArray?Array.isArray:function(t){return"[object Array]"===Object.prototype.toString.call(t)};var mt=dt,wt=Date.now||function(){return(new Date).getTime()},gt=Object.create||function(t){if(arguments.length>1)throw new Error("Second argument not supported");if("object"!=typeof t)throw new TypeError("Argument must be an object");return e.prototype=t,new e},bt={mixin:function(t){return t.on=this.on,t.off=this.off,t.trigger=this.trigger,t._promiseCallbacks=void 0,t},on:function(t,n){if("function"!=typeof n)throw new TypeError("Callback must be a function");var r,e=i(this);r=e[t],r||(r=e[t]=[]),-1===o(r,n)&&r.push(n)},off:function(t,n){var r,e,u=i(this);return n?(r=u[t],e=o(r,n),void(-1!==e&&r.splice(e,1))):void(u[t]=[])},trigger:function(t,n,r){var e,o,u=i(this);if(e=u[t])for(var s=0;s<e.length;s++)(o=e[s])(n,r)}},Et={instrument:!1};bt.mixin(Et);var At=[],jt=a,Tt=c,St=f,kt=h;h.prototype._validateInput=function(t){return mt(t)},h.prototype._validationError=function(){return new Error("Array Methods must be provided an Array")},h.prototype._init=function(){this._result=new Array(this.length)},h.prototype._enumerate=function(){for(var t=this.length,n=this.promise,r=this._input,e=0;n._state===xt&&t>e;e++)this._eachEntry(r[e],e)},h.prototype._settleMaybeThenable=function(t,n){var r=this._instanceConstructor,e=r.resolve;if(e===St){var o=b(t);if(o===Tt&&t._state!==xt)t._onError=null,this._settledAt(t._state,n,t._result);else if("function"!=typeof o)this._remaining--,this._result[n]=this._makeResult(Nt,n,t);else if(r===Pt){var i=new r(g);T(i,t,o),this._willSettleAt(i,n)}else this._willSettleAt(new r(function(n){n(t)}),n)}else this._willSettleAt(e(t),n)},h.prototype._eachEntry=function(t,n){r(t)?this._settleMaybeThenable(t,n):(this._remaining--,this._result[n]=this._makeResult(Nt,n,t))},h.prototype._settledAt=function(t,n,r){var e=this.promise;e._state===xt&&(this._remaining--,this._abortOnReject&&t===Yt?O(e,r):this._result[n]=this._makeResult(t,n,r)),0===this._remaining&&C(e,this._result)},h.prototype._makeResult=function(t,n,r){return r},h.prototype._willSettleAt=function(t,n){var r=this;R(t,void 0,function(t){r._settledAt(Nt,n,t)},function(t){r._settledAt(Yt,n,t)})};var Ct=p,Ot=_,Rt=v,It="rsvp_"+wt()+"-",Mt=0,Pt=m;m.cast=St,m.all=Ct,m.race=Ot,m.resolve=St,m.reject=Rt,m.prototype={constructor:m,_guidKey:It,_onError:function(t){var n=this;Et.after(function(){n._onError&&Et.trigger("error",t,n._label)})},then:Tt,"catch":function(t,n){return this.then(void 0,t,n)},"finally":function(t,n){var r=this,e=r.constructor;return r.then(function(n){return e.resolve(t()).then(function(){return n})},function(n){return e.resolve(t()).then(function(){return e.reject(n)})},n)}};var xt=void 0,Nt=1,Yt=2,Dt=new M,Kt=new M;Y.prototype=gt(kt.prototype),Y.prototype._superConstructor=kt,Y.prototype._makeResult=l,Y.prototype._validationError=function(){return new Error("allSettled must be called with an array")};var Ut,qt,Ft=D,Gt=K,Lt=0,Vt=({}.toString,U),Wt="undefined"!=typeof window?window:void 0,$t=Wt||{},zt=$t.MutationObserver||$t.WebKitMutationObserver,Bt="undefined"==typeof self&&"undefined"!=typeof process&&"[object process]"==={}.toString.call(process),Ht="undefined"!=typeof Uint8ClampedArray&&"undefined"!=typeof importScripts&&"undefined"!=typeof MessageChannel,Jt=new Array(1e3);qt=Bt?q():zt?G():Ht?L():void 0===Wt&&"function"==typeof require?$():V();var Qt=z,Xt=B,Zt=H;H.prototype=gt(kt.prototype),H.prototype._superConstructor=kt,H.prototype._init=function(){this._result={}},H.prototype._validateInput=function(t){return t&&"object"==typeof t},H.prototype._validationError=function(){return new Error("Promise.hash must be called with an object")},H.prototype._enumerate=function(){var t=this,n=t.promise,r=t._input,e=[];for(var o in r)n._state===xt&&Object.prototype.hasOwnProperty.call(r,o)&&e.push({position:o,entry:r[o]});var i=e.length;t._remaining=i;for(var u,s=0;n._state===xt&&i>s;s++)u=e[s],t._eachEntry(u.entry,u.position)},J.prototype=gt(Zt.prototype),J.prototype._superConstructor=kt,J.prototype._makeResult=l,J.prototype._validationError=function(){return new Error("hashSettled must be called with an object")};var tn,nn=Q,rn=X,en=Z,on=new tt,un=new tt,sn=ut;if("object"==typeof self)tn=self;else{if("object"!=typeof global)throw new Error("no global: `self` or `global` found");tn=global}var an=tn,cn=ft,fn=lt,ln=ht,hn=pt;Et.async=Vt,Et.after=function(t){setTimeout(t,0)};if("undefined"!=typeof window&&"object"==typeof window.__PROMISE_INSTRUMENTATION__){var pn=window.__PROMISE_INSTRUMENTATION__;u("instrument",!0);for(var _n in pn)pn.hasOwnProperty(_n)&&vt(_n,pn[_n])}var vn={race:cn,Promise:Pt,allSettled:Ft,hash:rn,hashSettled:nn,denodeify:sn,on:vt,off:yt,map:en,filter:Xt,resolve:ln,reject:fn,all:Gt,rethrow:hn,defer:Qt,EventTarget:bt,configure:u,async:_t};"function"==typeof define&&define.amd?define(function(){return vn}):"undefined"!=typeof module&&module.exports?module.exports=vn:"undefined"!=typeof an&&(an.RSVP=vn)}).call(this);